/// <reference path="../typings/index.d.ts" />

import * as sequelize from 'sequelize';

interface UserInterface {
    username?: string;
    password?: string;
    signupDate?: Date;
}

interface UserInstance extends sequelize.Instance<UserInstance, UserInterface>, UserInterface {}

interface UserModel extends sequelize.Model<UserInstance, UserInterface> {}

var UserInitialized: boolean = false;
export var User: UserModel;
export function initUser(seq: sequelize.Sequelize): void {
  if (UserInitialized) {
    return;
  }

  User = <UserModel>sequelize.define<UserInstance, UserInterface>('User', {
    'username': sequelize.STRING,
    'password': sequelize.STRING,
    'signupDate': sequelize.DATE
  });

  UserInitialized = true;
}

export function init(seq: sequelize.Sequelize): void {
  initUser(seq);
};